//+------------------------------------------------------------------+
//|                                                   LSMA trend.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property  copyright "mladen"
#property  link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue
#property indicator_color2 PaleVioletRed
#property indicator_width1 1
#property indicator_width2 1

//
//
//
//
//

extern int                LSMAPeriod     = 35;
extern ENUM_APPLIED_PRICE LSMAPrice       =  0;
extern int                ArrowCode       = 159; 
extern bool               alertsOn        = true;
extern bool               alertsOnCurrent = false;
extern bool               alertsMessage   = true;
extern bool               alertsSound     = true;
extern bool               alertsNotify    = false;
extern bool               alertsEmail     = false;
extern string             soundFile       = "alert2.wav";


//
//
//
//
//

double Up[];
double Dn[];
double trend[];
double lsma[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,Up); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,ArrowCode);
   SetIndexBuffer(1,Dn); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,ArrowCode);
   SetIndexBuffer(2,trend);
   SetIndexBuffer(3,lsma);
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{ 
   int counted_bars=IndicatorCounted();
   int limit,i;


   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(i = limit; i >= 0; i--)
      {
         lsma[i] = 3.0*iMA(NULL,0,LSMAPeriod,0,MODE_LWMA,LSMAPrice,i)-2.0*iMA(NULL,0,LSMAPeriod,0,MODE_SMA,LSMAPrice,i);
         Up[i]    = EMPTY_VALUE;
         Dn[i]    = EMPTY_VALUE;
         trend[i] = trend[i+1];
         if (lsma[i]>lsma[i+1]) trend[i] =  1;
         if (lsma[i]<lsma[i+1]) trend[i] = -1;
         if (trend[i] ==  1) Up[i] = lsma[i];
         if (trend[i] == -1) Dn[i] = lsma[i];
      }  
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;
        if (trend[whichBar] != trend[whichBar+1])
        if (trend[whichBar] == 1)
              doAlert("sloping up");
        else  doAlert("sloping down");       
   }
   return(0);
}      

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];
          
          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," LSMA ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," LSMA  "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

